概述
平时里算法被np喷,说不像cs毕业的像数学院毕业的,以后经常写一写leetcode练练吧T T
果然第一练就gg了呢
给定一个整数数组 nums
和一个目标值 target
,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。
你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。
示例:
给定 nums = [2, 7, 11, 15], target = 9
因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]
第一遍:
class Solution:
def twoSum(self, nums: List[int], target: int) -> List[int]:
for i in range(0,len(nums)):
cur = nums[i]
for j in range(0,i):
comp = nums[j]
if target == cur+comp:
re = [i,j]
re.sort()
return re
for j in range(i+1,len(nums)):
comp = nums[j]
if target == cur+comp:
re = [i,j]
re.sort()
return re
执行用时 : 7548 ms, 在Two Sum的Python3提交中击败了7.84% 的用户
内存消耗 : 13.8 MB, 在Two Sum的Python3提交中击败了0.84% 的用户
第二遍:
看了别人写的,就算不用字典起码也不用遍历前面的(0,i)吧,真是服了自己
class Solution:
def twoSum(self, nums: List[int], target: int) -> List[int]:
for i in range(0,len(nums)):
cur = nums[i]
for j in range(i+1,len(nums)):
comp = nums[j]
if target == cur+comp:
re = [i,j]
re.sort()
return re
执行用时 : 5724 ms, 在Two Sum的Python3提交中击败了30.81% 的用户
内存消耗 : 13.8 MB, 在Two Sum的Python3提交中击败了0.84% 的用户
第三遍
用字典,一边搜一边加
class Solution:
def twoSum(self, nums: List[int], target: int) -> List[int]:
hashmap = {}
for i, ele in enumerate(nums):
comp = target -ele
if comp in hashmap:
re = [hashmap[comp],i]
re.sort()
return re
hashmap[ele] = i
return None
执行用时 : 56 ms, 在Two Sum的Python3提交中击败了68.42% 的用户
内存消耗 : 14.3 MB, 在Two Sum的Python3提交中击败了0.84% 的用户
最后
以上就是帅气绿茶为你收集整理的leetcode | python | 两数之和的全部内容,希望文章能够帮你解决leetcode | python | 两数之和所遇到的程序开发问题。
如果觉得靠谱客网站的内容还不错,欢迎将靠谱客网站推荐给程序员好友。
本图文内容来源于网友提供,作为学习参考使用,或来自网络收集整理,版权属于原作者所有。
发表评论 取消回复